#ifndef LIBXMLWRAP_HEAP_PTR_H
#define LIBXMLWRAP_HEAP_PTR_H

#include <libxml/globals.h>

namespace xml
{

template< class T >
class heap_ptr : boost::noncopyable
{
public:
	explicit heap_ptr( T * p ) : ptr_( p ) {}
	~heap_ptr() { if( ptr_ ) xmlFree( ptr_ ); }

	T * get() const throw() { return ptr_; }
private:
	T * ptr_;
};

typedef heap_ptr< xmlChar > heap_str;

} // namespace xml

#endif // LIBXMLWRAP_HEAP_PTR_H
